<template>
<!-- eslint-disable -->
  <v-container
    id="regular-tables"
    fluid
    tag="section"
  >
  <v-layout align-start justify-center>
    <v-flex xs4 class="elevation-1 pa-3 ma-2">
      <v-list two-line>
        <v-subheader>
          Portofolios
        </v-subheader>
          <div v-for="item in portofolios" :key="item.id">
            <v-btn
              text
              color="primary"
              @click="selectPortofolio(item)"
            >
              {{item.name}}
            </v-btn>
          </div>
      </v-list>
    </v-flex>
    <v-flex xs4 class="elevation-1 pa-3 ma-2" v-if="isPortofolioSelected">
      <v-list two-line>
        <v-subheader>
          No Portofolio Selected
        </v-subheader>
          <div v-for="item in selectedPotofolioItems" :key="item.id">
            <p class="font-weight-medium">
              {{item.name}}
            </p>
          </div>
      </v-list>
    </v-flex>

    <v-flex xs4 class="elevation-1 pa-3 ma-2">
      <v-expansion-panels>
        <v-expansion-panel>
          <v-expansion-panel-header>Stocks Available</v-expansion-panel-header>
          <v-expansion-panel-content>
          <v-switch
            v-model="isUnlockedForSave"
            label="Update portofolio"
          ></v-switch>
            <div v-for="item in stocks" :key="item.id">
              <v-icon
                  large
                  color="green darken-2"
                >
                  mdi-domain
                </v-icon>
              <v-btn :disabled="!isUnlockedForSave"
                text
                @click="addToPortofolio(item.id)"
              >
                <span class="font-weight-medium">
                  {{item.name}} ({{item.holdings}})
                </span>
              </v-btn>
            </div>
          </v-expansion-panel-content>
        </v-expansion-panel>
      </v-expansion-panels>
    </v-flex>
  </v-layout>
  <p class="font-weight-medium" v-if="potorfolioIdToEdit">
    {{ selectedPotofolioName }}
  </p>
  <p class="font-weight-medium" v-else>
    No portofolio selected
  </p>
  <v-simple-table dense>
    <template v-slot:default>
      <thead>
        <tr>
          <th class="text-left">
            Name
          </th>
          <th class="text-left">
            Holdings
          </th>
          <th class="text-left">
            Actions
          </th>
        </tr>
      </thead>
      <tbody>
        <tr
          v-for="item in selectedPotofolioStocks"
          :key="item.id"
        >
          <td>{{ item.name }}</td>
          <td>{{ item.holdings }}</td>
          <td>
            <v-btn
              icon
              color="primary"
              @click="removeStock(item.id)"
            >
              <v-icon>mdi-alpha-x</v-icon>
            </v-btn>
          </td>
        </tr>
      </tbody>
    </template>
  </v-simple-table>
  </v-container>
</template>

<script>
  import * as Cfg from '@/middleware/configSettings.ts'

  const axios = require('axios')

  export default {
    data () {
      return {
        headers: [
        ],
        portofolios: [],
        selectedPotofolioStocks: [],
        selectedPotofolioName: '',
        stocks: [],
        isPortofolioSelected: false,
        potorfolioIdToEdit: {},
        selectedPotofolio: {},
        isUnlockedForSave: true,
      }
    },
    created () {
      this.init()
    },
    methods: {
      init () {
        const url = Cfg.url.urlStocks
        axios.get(url).then(resp => {
          this.portofolios = resp.data.payload.portofolios
          this.stocks = resp.data.payload.availableStocks
        })
      },
      selectPortofolio (item) {
        this.potorfolioIdToEdit = item
        this.selectedPotofolioName = item.name
        const url = Cfg.url.urlPortofolios + '/' + item.id
        axios.get(url).then(resp => {
          this.selectedPotofolio = resp.data.payload
          this.selectedPotofolioStocks = resp.data.payload.stocks
        })
      },
      addToPortofolio (stockId) {
        if (this.potorfolioIdToEdit == null || this.potorfolioIdToEdit === '') {
          alert('Select portofolio')
        }
        const url = Cfg.url.urlPortofolios + '/' + this.potorfolioIdToEdit.id + '?stockId=' + stockId
        axios.post(url).then(resp => {
          this.selectPortofolio(this.potorfolioIdToEdit)
        })
      },
      removeStock (stockId) {
        const url = Cfg.url.urlPortofolios + '/' + this.potorfolioIdToEdit.id + '/stocks/' + stockId
        axios.delete(url).then(resp => {
          this.selectPortofolio(this.potorfolioIdToEdit)
        })
      },
    },
  }
</script>
<style scoped>
.disableCondition {
  pointer-events: none
}
</style>
